package crypt;
import java.util.Hashtable;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.BevelBorder;
import java.awt.event.*;


/**
 * @author Grazz, Andy
 */
public class Genesis extends JFrame implements ActionListener {

	Workspace workArea = new Workspace();
	Module activeModule;
	ModuleList modules = new ModuleList(this, activeModule);
	JLayeredPane layers;

	Hashtable panels = new Hashtable();
	JPanel cards;
	String[] types = { "About", "Base 64","Diffe-Hellman Key Agreement", "Digital Certificates"
		,"Digital Signatures","Hashing","JCE Built In Support","Modulo Arithmetic","Public Key:DES"
		,"Public Key:RSA","SSL"};
	int startType = 1;

	// Default constructor
	public Genesis(int width,int height) {

		//Module loading
		panels.put(types[0], new DefaultModule("About this program",width,height));
		panels.put(types[1], new Base64Module("Base 64 encoding",width,height));
		panels.put(types[2], new DefaultModule("The Diffe-Hellman Key Agreement Protocol",width,height));
		panels.put(types[3], new DefaultModule(types[3],width,height));
		panels.put(types[4], new DefaultModule(types[4],width,height));
		panels.put(types[5], new DefaultModule(types[6],width,height));
		panels.put(types[6], new JceModule("Encryption algorithms built into java via JCE",width,height-75));
		panels.put(types[7], new DefaultModule(types[7],width,height));
		panels.put(types[8], new DefaultModule(types[8],width,height));
		panels.put(types[9], new DefaultModule(types[9],width,height));
		panels.put(types[10], new DefaultModule("The Secure Socket Layer",width,height));		

		JPanel main = new JPanel();

		main.setPreferredSize(new Dimension(width, height));

		main.setLayout(new BorderLayout());

		cards = new JPanel(new CardLayout());

		for (int i = 0; i < types.length; i++) {
			add(types[i]);
		}
		((CardLayout) cards.getLayout()).show(cards, types[startType]);

		main.add(cards, BorderLayout.CENTER);

		JPanel south = new JPanel(new BorderLayout());

		JPanel horizontalBar = new JPanel();
		horizontalBar.setPreferredSize(new Dimension(width, 10));
		horizontalBar.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));

		JPanel controls = new JPanel();
		controls.setPreferredSize(new Dimension(width, 65));

		for (int i = 0; i < types.length; i++) {
			JButton button = new JButton(types[i]);
			button.setActionCommand("change" + new Integer(i).toString());
			button.addActionListener(this);
			controls.add(button);
		}

		south.add(horizontalBar, BorderLayout.NORTH);
		south.add(controls, BorderLayout.CENTER);

		main.add(south, BorderLayout.SOUTH);
		
		getContentPane().add(main);
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		
	}
	
	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if (command.startsWith("change")) {
			String right = command.substring(6);
			int num = new Integer(right).intValue();
			((CardLayout) cards.getLayout()).show(cards, types[num]);

			//			((CardLayout) cards.getLayout()).next(cards);
			//			cards.paintImmediately(0,0,cards.getWidth(), cards.getHeight());
		} else if (command.equalsIgnoreCase("")) {
		} else if (command.equalsIgnoreCase("")) {
		} else if (command.equalsIgnoreCase("")) {
		} else if (command.equalsIgnoreCase("")) {
		} else if (command.equalsIgnoreCase("")) {
		}
	}
		
	private void add(String name) {
		cards.add(name, (Module) panels.get(name));
	}
}
