package crypt.jce;

/*
BlobPanel.java
Draggable box that contains a reference to BlobFile (Store for the plain/encrypted text)
*/

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

public class BlobPanel extends JPanel implements MouseMotionListener, MouseListener {

	private BlobFile blobfile;
	private int offsetx;
	private int offsety;

	public BlobFile getBlobFile () {
		return blobfile;
	}

	public void setBlobFile (BlobFile newBlobFile) {
		blobfile = newBlobFile;
	}

	public BlobPanel (String label, String desc) {
		setBlobFile (new BlobFile());
		setBounds(32,32,32,32);
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		add(new JLabel(label));
		add(new JLabel(desc));
		addMouseMotionListener(this);
		addMouseListener(this);
		this.setName(label);
	}

	public void mousePressed(MouseEvent e) {
		offsetx = e.getX();
		offsety = e.getY();
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mouseClicked(MouseEvent e) {
		if (e.getClickCount() == 2)
		{
			System.out.println("Double clicked on "+this.getName());
		}
	}

	public void mouseMoved(MouseEvent e) {
		// dukeLabel.setLocation(e.getX()-XFUDGE, e.getY()-YFUDGE);
	}

	public void mouseDragged(MouseEvent e) {
	}
}

