package crypt.jce;

import java.util.Random;

import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;

public class CryptKey
{
	SecretKey[] key;
	String phrase;
	int algcount;
	boolean phraserandom;

	public CryptKey ()
	{
		// Create a random key for each algorithm Java knows about
		String[] cipherStrings = CryptUtils.getSymmetricCiphers();
		key = new SecretKey[cipherStrings.length];
		algcount = cipherStrings.length;

		for (int i = 0 ; i < cipherStrings.length ; i++)
		{
			try
			{
				key[i] = KeyGenerator.getInstance(cipherStrings[i]).generateKey();
			}
			catch(Exception e)
			{
				System.out.println("Error in CryptKey() : " + e.toString());
			}
		}

		// This might be better with some exciting abstract classes, but for now
		// I just want something that will work :)
		String words[] = {"RANDOM", "BISCUIT", "LEMMING", "CHEESE", "DANDRUFF", "LIBRARY", "CHANNEL", "CONGRATS", "OPERATION", "BLONDE"};
		Random r = new Random();
		phrase = words[r.nextInt(words.length)];
		phraserandom = true;

	}
	
	public boolean getPhraseRandom() {
		return phraserandom;
	}

	public SecretKey getKey(int i)
	{
		if (i >= key.length) {
			return null;
		}
		return key[i];
	}
	
	public String getPhrase() {
		return phrase;
	}
}
