package crypt.jce;

/*
FilePanel.java
Draggable box that contains a reference to BlobFile (Store for the plain/encrypted text)
*/
import javax.swing.JLayeredPane;

public class FilePanel extends MobilePanel {

	private BlobFile blobfile;

	public BlobFile getBlobFile () {
		return blobfile;
	}

	public void setBlobFile (BlobFile newBlobFile) {
		blobfile = newBlobFile;
	}

	public FilePanel (String label, String desc) {
		super(label,desc);
		blobfile = new BlobFile();
		setSweetSpot(0,0,640,200);
		this.setToolTipText(blobfile.getText());
	}
	
	public FilePanel (String label, String desc, String blobtext) {
		super(label,desc);
		blobfile = new BlobFile(blobtext);
		setSweetSpot(0,0,640,200);
		this.setToolTipText(blobtext);
	}

	public void sweetSpot() {
	  // Woohoo, that means where still in scratch space :)
		FilePanel out = this.getGUIParent().getCryptOutput();
		/* Check to see if I'm the output panel */
		if (this == out) {
			FilePanel newSource = new FilePanel(this.getTop().getText(), this.getBottom().getText(), this.getBlobFile().getText() );
			newSource.setParent(this.getGUIParent());
			newSource.setBounds(this.getX(), this.getY(), this.getWidth(), this.getHeight() );
			this.getGUIParent().getLayers().add(newSource, JLayeredPane.PALETTE_LAYER);
			this.getGUIParent().revalidate();
			this.setLocation(this.startx, this.starty);
		}
	}

	public void otherSpot(int x, int y) {
		FilePanel work = this.getGUIParent().getCryptInput();
		if (this == work)
			return;

		FilePanel out = this.getGUIParent().getCryptOutput();
		if (this == out) {
			this.getGUIParent().getEncryptButton().setText("Decrypt");
		}
		else {
			this.getGUIParent().getEncryptButton().setText("Encrypt");
		}

		int x1 = work.getX();
		int y1 = work.getY() + 200;
		int x2 = x1 + work.getWidth();
		int y2 = y1 + work.getHeight() + 200;

		if (x > x1 && y > y1 && x < x2 && y < y2) {
			work.setBlobFile(getBlobFile());
			work.rewrite(this.getTop().getText(), this.getBottom().getText());
			work.setToolTipText(work.getBlobFile().getText());
			System.out.println("Hit input box!");

		}
	}

	public void notSweetSpot() {
		// Get back in the scratch
		this.setLocation(this.startx, this.starty);
	}

}

