package crypt.jce;

/*
KeyPanel.java
Draggable box that contains a reference to CryptKey (Store for a key for all algorithms)
*/
import javax.swing.JLabel;

public class KeyPanel extends MobilePanel {

	private CryptKey key;
	boolean active;

	public CryptKey getKey ()
	{
		if (active == true)
			return key;
		else
			return null;
	}

	public void setKey (CryptKey newKey)
	{
		key = newKey;
	}

	public KeyPanel (String label, String desc) {
		super(label,desc);
		key = new CryptKey();
		setActive(true);
		setSweetSpot(0,0,640,200);

		if (key.getPhrase().equals("") == false)
		{
			String tip = "";
			if (key.getPhraseRandom() == true)
			{
				tip = "Random ";
			}
			tip = tip + "Keyphrase: "+key.getPhrase();
			this.setToolTipText(tip);
		}
	}

    public KeyPanel (String filename) {
		super(filename);
		key = new CryptKey();
		setActive(true);
		setSweetSpot(0,0,640,200);
    }

	public void setActive(boolean i)
	{
		active = i;
	}

	public void sweetSpot() {
	  // Woohoo, that means where still in scratch space :)

	}

	public void otherSpot(int x, int y) {
	// There are methods to do this in the Container class, but implementing
	// it from first principles makes it easier to make sure it's doing exactly
	// what we want.
		KeyPanel work = this.getGUIParent().getKeyInput();
		if (this == work)
			return;
		int x1 = work.getX();
		int y1 = work.getY() + 200;
		int x2 = x1 + work.getWidth();
		int y2 = y1 + work.getHeight() + 200;

		if (x > x1 && y > y1 && x < x2 && y < y2) {
			work.setKey(getKey());
			work.setActive(true);
			work.remove(work.getBottom());
			work.remove(work.getTop());
			JLabel newTop = new JLabel(this.getTop().getText());
			JLabel newBottom = new JLabel(this.getBottom().getText());
			work.add(newTop);
			work.add(newBottom);
			work.setTop(newTop);
			work.setBottom(newBottom);
			work.revalidate();
			System.out.println("Hit key input!");

		}
	}

	public void notSweetSpot() {
		// Check where we are and see if it matches the
		// Get back in the scratch
		this.setLocation(this.startx, this.starty);
	}
}

